// C Source File
// Created 25/09/03; 02:52:48 p.m.
#define OPTIMIZE_ROM_CALLS
#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200
#define MIN_AMS 200           // Compile for AMS 1.00 or higher
#include <tigcclib.h>         // Include All Header Files
#include "intro.h"
#include "password.h"

//Global uninitialized varibles
unsigned long int binUse, bfreeAfterGC, bfree, bunusedSectors;

//functions prototype
int InputStr(char *buffer, unsigned short maxlen);
void drawbox(short x, short y, short width, short height, short fill, short mode);
void escribir_menu(short x, short y);
void acercade(void);
void battdraw(void);
unsigned short BatteryState(unsigned short is_hw_2);
void mem_calc_menu(short x, short y);
void mem_calc_win(WINDOW *wind);
void MemInfo(void);
void IntToStr (unsigned long int an_integer, WINDOW*W);
void CalcInfo(void);
void system_menu(short x, short y);
void system_win(WINDOW *wind, char ispass[1], char password[9], char splashScreen[1]);
void APD_menu(short x, short y);
void APD_win(WINDOW *wind);
void APD_NORMAL(void);
void APD_SEGUNDOS(void);
void APD_custom_menu(short x, short y);
void APD_custom_win(WINDOW *wind);
void APD_minutos(void);
void key_menu(short x, short y);
void key_win(WINDOW *wind);
void KeyRep(void);
void keyRep_Fast(void); 
void keyRep_slow(void);
void keyRep_Normal(void);
void pass_win(WINDOW *wind,char ispass[1], char password[9]);
void pass_menu(short x, short y);
void intro_win(WINDOW *wind, char splashScreen[1]);
void intro_menu(short x, short y);
void no_pass(void);
void yes_intro(void);
void no_intro(void);

// Main Function
void _main(void)
{
	char temp_screen[3840];
	memmove(temp_screen, LCD_MEM, 3840); //saves lcd contents to the pointer to the graphic buffer 
	char splashScreen[1];
  char ispass[1];
  char password[9];
  if ((strlen(ispass)!=0) && (ispass[0]=='s')){
		 askPassword(password);
	}
  if ((strlen(splashScreen)==0) || (splashScreen[0]=='s')){
  	intro();
  }
  WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-30,(LCD_HEIGHT/2)-30, (LCD_WIDTH/2)+30, (LCD_HEIGHT/2)+30), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER| WF_TITLE ,"sYsMaNaGeR 1.3");
  WinActivate (wind);
  WinFont (wind, F_4x6);
	short width=60;
	short height=30; 
	short x = (LCD_WIDTH/2) - (width/2);
	short y = (LCD_HEIGHT/2) - (height/2);
	drawbox(x,y+3,width,6,1,A_OR);
	escribir_menu(x,y);
	ST_refDsp (12);
	int menu_point=0;
	short y1=y+3;
	int key= ngetchx();
	while (key != KEY_ESC){
		if (key != (KEY_DOWN || KEY_UP || KEY_ESC || KEY_ENTER)){
	  ST_refDsp (12);
		menu_point=menu_point;
		key=key;
		}
		if (key==KEY_ENTER){
			if (menu_point==3){
					acercade();
		  }
		  if (menu_point==2){
		  	battdraw();
		  }
		  if (menu_point==1){
		  	WinClr (wind);
		  	mem_calc_win(wind);
		  	WinClr (wind);
		  	drawbox(x,y1,width,6,1,A_OR);
				escribir_menu(x,y);
			}
			if (menu_point==0){
				WinClr (wind);
				system_win(wind,ispass,password,splashScreen);
				WinClr (wind);
		  	menu_point=menu_point;
				key=key;
		  	drawbox(x,y1,width,6,1,A_OR);
				escribir_menu(x,y);
			}	
		} 
		if(key == KEY_DOWN){ 
		  WinClr (wind);
		  if (menu_point!=3 ){
				y1=y1+10;
				drawbox(x,y1,width,6,1,A_OR);
		  	escribir_menu(x,y);
				menu_point=menu_point+1;
    	}else{
				y1=y+3;
				drawbox(x,y1,width,6,1,A_OR);
		  	escribir_menu(x,y);
				menu_point=0;
    	}
		}
		if(key == KEY_UP){ 
		  WinClr (wind);
		  if (menu_point !=0 ){
				y1=y1-10;
				drawbox(x,y1,width,6,1,A_OR);
				escribir_menu(x,y);
				menu_point=menu_point-1;
			}else{
				y1=y+33;
				drawbox(x,y1,width,6,1,A_OR);
		  	escribir_menu(x,y);
				menu_point=3;
    	}		
		}
	key=ngetchx();
	}
	WinClose (wind);
  HeapFreePtr (wind);
	memmove(LCD_MEM, temp_screen, 3840); //restores lcd screen
	ST_helpMsg ("SM_V1.3_sanchop@starmedia.com");	
}

/*WRITES THE main MENU ON THE SCREEN*/
void escribir_menu(short x, short y){
	DrawStr(x+13,y+3,"SYSTEM",A_XOR);
	DrawStr(x+13,y+13,"MEM & CALC",A_XOR);
	DrawStr(x+13,y+23,"BATTERIES",A_XOR);	
	DrawStr(x+13,y+33,"ABOUT..",A_XOR);		
}

/*DRAWS A BOX TAKEN FROM JUDE NELSON'S MENUS*/
void drawbox(short x, short y, short width, short height, short fill, short mode)
{
	DrawClipLine(&(WIN_RECT){x,y,x+width,y}, &(SCR_RECT){{0,0,LCD_WIDTH-1, LCD_HEIGHT-1}}, mode);
	DrawClipLine(&(WIN_RECT){x,y,x,y+height}, &(SCR_RECT){{0,0,LCD_WIDTH-1, LCD_HEIGHT-1}}, mode);
	DrawClipLine(&(WIN_RECT){x+width,y,x+width,y+height}, &(SCR_RECT){{0,0,LCD_WIDTH-1, LCD_HEIGHT-1}}, mode);
	DrawClipLine(&(WIN_RECT){x,y+height,x+width,y+height}, &(SCR_RECT){{0,0,LCD_WIDTH-1, LCD_HEIGHT-1}}, mode);
	if(fill == 1)
	{
		short i;
		for(i=1; i<height; i++)
		{
			DrawClipLine(&(WIN_RECT){x,y+i,x+width,y+i}, &(SCR_RECT){{0,0,LCD_WIDTH-1, LCD_HEIGHT-1}}, mode);
		}
	}
}

/*ABOUT..*/
void acercade(void)
{
  WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-55,(LCD_HEIGHT/2)-25, (LCD_WIDTH/2)+55, (LCD_HEIGHT/2)+25), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"ABOUT..");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, " SysManager v.1.3");
  WinStr (wind, "\n sanchop@starmedia.com");
  WinStr (wind, "\n nsanchez@javeriana.edu.co");
  WinStr (wind, "\n Download at www.ticalc.org");
  WinStr (wind, "\n MADE IN C O L O M B I A!!!");
  ngetchx ();
  WinClose (wind);
  HeapFreePtr (wind);
}

/*BATTERY STATE*/
asm("BatteryState:\n"
"           movem.l  %d1/%a0-%a1,-(%sp)\n"
"           tst.w   16(%sp)           | jump for HW1\n"
"           beq     _bat_h1_1\n"
"           lea     0x70001D,%a0\n"
"           move.b  (%a0),%d0\n"
"           ori.b   #9,%d0\n"
"           move.b  %d0,(%a0)\n"
"_bat_h1_1: moveq   #6,%d1\n"
"           lea     0x600018,%a1\n"
"_bat_loop: bsr.s   _bat_ini         | this initialization lacked in previous versions\n"
"           move.w  %d1,%d0\n"
"           lsl.w   #7,%d0\n"
"           move.w  %d0,(%a1)\n"
"           moveq   #0x6e,%d0\n"
"_bat_test: btst.b  #2,-0x18(%a1)\n"
"           dbeq    %d0,_bat_test\n"
"           beq.s   _bat_quit\n"
"           dbf     %d1,_bat_loop\n"
"_bat_quit: neg.w   %d1\n"
"           addq.w  #6,%d1\n"
"           tst.w   4(%sp)\n"
"           beq.s   _bat_h1_2        | jump for HW1\n"
"           and.b   #0xF7,(%a0)\n"
"           bsr.s   _bat_ini\n"
"           andi.b  #0xF6,(%a0)\n"
"_bat_h1_2: move.w  %d1,%d0\n"
"           movem.l (%sp)+,%d1/%a0-%a1\n"
"           rts\n"
"_bat_ini:  move.w  #0x380,(%a1)\n"
"           moveq   #52,%d0\n"
"_bat_wait: btst.b  #2,-0x18(%a1)\n"
"           dbeq    %d0,_bat_wait\n"
"           rts");

/*DRAWS batTerY STATE*/
void battdraw(void)
{
  WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-75,(LCD_HEIGHT/2)-25, (LCD_WIDTH/2)+75, (LCD_HEIGHT/2)+25), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"BATTERY STATE");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  DrawLine ((LCD_WIDTH/2)-55, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)+55, (LCD_HEIGHT/2)+5, A_XOR);
  DrawLine ((LCD_WIDTH/2)-55, (LCD_HEIGHT/2)+15, (LCD_WIDTH/2)+55, (LCD_HEIGHT/2)+15, A_XOR);
  DrawLine ((LCD_WIDTH/2)-55, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)-55, (LCD_HEIGHT/2)+15, A_XOR);
  DrawLine ((LCD_WIDTH/2)+55, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)+55, (LCD_HEIGHT/2)+15, A_XOR);
  int j;
  if (BatteryState(1)==0){ 
  	WinStr (wind, "CHARGE:0%");
  }
  if (BatteryState(1)==1) {
  	WinStr (wind, "CHARGE:14.3% aPROX.");
   	for (j=0;j<15;j++){
  	DrawLine ((LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+15, A_XOR);
  	}
  }
  if (BatteryState(1)==2) {
  	WinStr (wind, "CHARGE:28.6% aPROX.");
   	for (j=0;j<32;j++){
  	DrawLine ((LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+15, A_XOR); 
  	}
  }
  if (BatteryState(1)==3) {
  	WinStr (wind, "CHARGE:42.9% aPROX.");
   	for (j=0;j<47;j++){
  	DrawLine ((LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+15, A_XOR);
		}  
  }
  if (BatteryState(1)==4) {
  	WinStr (wind, "CHARGE:57.14% aPROX.");
   	for (j=0;j<63;j++){
  	DrawLine ((LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+15, A_XOR);
  	}
  }
  if (BatteryState(1)==5) {
  	WinStr (wind, "CHARGE:71.4% aPROX.");
   	for (j=0;j<78;j++){
  	DrawLine ((LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+15, A_XOR);
  	}
  }
  if (BatteryState(1)==6) {
  	WinStr (wind, "CHARGE:85.7% aPROX.");
   	for (j=0;j<94;j++){
  	DrawLine ((LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+15, A_XOR);
  	}
  }
    if (BatteryState(1)==7) {
  	WinStr (wind, "CHARGE:100%");
   	for (j=0;j<110;j++){
  	DrawLine ((LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+5, (LCD_WIDTH/2)-55+j, (LCD_HEIGHT/2)+15, A_XOR);
  	}
  }
  WinStr (wind, "\nWARNING: Rechargeable batts wont give a good reading!!!!!!!");
  ngetchx ();
  WinClose (wind);
  HeapFreePtr (wind);
}

/*WRITES THE mem & calc MENU ON THE SCREEN*/
void mem_calc_menu(short x, short y){
	DrawStr(x+13,y+3,"MEMORY",A_XOR);
	DrawStr(x+13,y+13,"CALCULATOR",A_XOR);
}

/*MEM & CALC WINDOW*/
void mem_calc_win(WINDOW *wind){
  short width=60;
	short height=15; 
	short x = (LCD_WIDTH/2) - (width/2);
	short y = (LCD_HEIGHT/2) - (height/2);
	drawbox(x,y+3,width,6,1,A_OR);
	mem_calc_menu(x,y);
	ST_refDsp (12);
	int menu_point=0;
	short y1=y+3;
	int key= ngetchx();
	while (key != KEY_ESC){
		if (key != (KEY_DOWN || KEY_UP || KEY_ESC || KEY_ENTER)){
	  ST_refDsp (12);
		menu_point=menu_point;
		key=key;
		}
		if (key==KEY_ENTER){
			if (menu_point==0){
					MemInfo();						
		  }
		  if (menu_point==1){
		  		CalcInfo();
		  }
		} 
		if(key == KEY_DOWN){ 
		  WinClr (wind);
		  if (menu_point!=1 ){
				y1=y1+10;
				drawbox(x,y1,width,6,1,A_OR);
		  	mem_calc_menu(x,y);
				menu_point=menu_point+1;
			}else{
				y1=y+3;
				drawbox(x,y1,width,6,1,A_OR);
				mem_calc_menu(x,y);
				menu_point=0;
			}
		}
		if(key == KEY_UP){ 
		  WinClr (wind);
		  if (menu_point !=0 ){
				y1=y1-10;
				drawbox(x,y1,width,6,1,A_OR);
				mem_calc_menu(x,y);
				menu_point=menu_point-1;
    	}else{
				y1=y+13;
				drawbox(x,y1,width,6,1,A_OR);
		  	mem_calc_menu(x,y);
				menu_point=1;
    	}		
		}
	key=ngetchx();
	}
}

/*mem info*/
void MemInfo(void){
	binUse=0, bfreeAfterGC=0, bfree=0, bunusedSectors=0 ;	
	char temp_screen[3840];
	memmove(temp_screen, LCD_MEM, 3840); //saves lcd contents to the pointer to the graphic buffer 
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect (1,1, LCD_WIDTH-1, LCD_HEIGHT-1), WF_SAVE_SCR | WF_TTY );
  WinActivate (wind);
  WinFont (wind, F_6x8);
	WinClr (wind);
	WinStr (wind,"Memory Info");
  WinStr (wind,"\n");
	EM_survey (&binUse, &bfree, &bfreeAfterGC, &bunusedSectors, NULL, NULL);
  /*archive management*/
  WinStr (wind,"\nUsed Archive:");
	IntToStr(binUse,wind);
	WinStr (wind,"\nFree Archive:");
	IntToStr(bfreeAfterGC+bfree,wind);
	/*ram management*/
	long int fr=188000-bfree+57344;
	WinStr(wind,"\nUsed Ram");
	long int ur=188000-(fr);
	IntToStr(ur,wind);
	WinStr(wind, "\nFree Ram");
	IntToStr(fr,wind);
	WinStr(wind,"\nUnused Sectors:");
	IntToStr(bunusedSectors,wind);
	long int archivefree=(100-(100*binUse)/(bfreeAfterGC+bfree+binUse));
	long int ramfree=(100*(fr)/188000);
	WinStr(wind,"\n");
	IntToStr(archivefree,wind);
	WinStr(wind,"% of free archive");
	WinStr(wind,"\n");
	IntToStr(ramfree,wind);
	WinStr(wind,"% of free Ram");
	WinFont (wind, F_4x6);
	WinStr (wind,"\n\nWARNING: wrong values with the VTI!!");
	ngetchx();
  WinClose (wind);
  HeapFreePtr (wind);
  memmove(LCD_MEM, temp_screen, 3840); //restores lcd screen

}

/*int to char*/
void IntToStr (unsigned long int an_integer, WINDOW*W)
{
  char result [] ="       \0";    // 7 spaces and \0
  char *ptr = result + 7;
  while (an_integer)
    {
      *ptr-- = an_integer % 10 + '0';
      an_integer/=10;
    }
  WinStr(W,ptr);
}

/*calc info*/
void CalcInfo(void){
	char temp_screen[3840];
	memmove(temp_screen, LCD_MEM, 3840); //saves lcd contents to the pointer to the graphic buffer 
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect (1,1, LCD_WIDTH-1, LCD_HEIGHT-1), WF_SAVE_SCR | WF_TTY );
  WinActivate (wind);
  WinFont (wind, F_6x8);
	WinClr (wind);
	char buffer3[50];
	AB_prodid (buffer3);
	char buffer4[50];
	AB_serno (buffer4);
	WinStr (wind,"Calculator Info");
  WinStr (wind,"\n");
  if (CALCULATOR==1) WinStr (wind,"TI 92+\n");
	if (CALCULATOR==0) WinStr (wind,"TI 89\n");
	if (CALCULATOR==3) WinStr (wind,"TI Voyage200\n");
	WinStr (wind,"ID:");
	WinStr (wind,buffer3);
	WinStr (wind,"\nSerial:");
	WinStr (wind,buffer4); 
	WinStr (wind,"\nHardware Version:");
	int hwv = AB_getGateArrayVersion(); 
  if (hwv==1) WinStr (wind,"1");
  else WinStr (wind,"2"); 
  WinStr (wind,"\nAMS Version (OS):");
  WinStr (wind,ReleaseVersion);
  WinStr (wind,"\nRelease Date:");
  WinStr (wind,ReleaseDate);
	WinStr (wind,"\nAMS Size:");
	long int amsize=GetAMSSize();
	IntToStr(amsize,wind);
	WinStr (wind," Bytes");
	if (BatteryState(1)==0) WinStr (wind,"\nBatteries: Dead!");
	if (BatteryState(1)==1) WinStr (wind,"\nBatteries: Almost Dead");
	if (BatteryState(1)==2) WinStr (wind,"\nBatteries: Starving");
	if (BatteryState(1)==3) WinStr (wind,"\nBatteries: Very Low");
	if (BatteryState(1)==4) WinStr (wind,"\nBatteries: Low");
	if (BatteryState(1)==5) WinStr (wind,"\nBatteries: Medium");
	if (BatteryState(1)==6) WinStr (wind,"\nBatteries: OK");
	if (BatteryState(1)==7) WinStr (wind,"\nBatteries: Full!");
	ngetchx();
	WinClose (wind);
  HeapFreePtr (wind);
  memmove(LCD_MEM, temp_screen, 3840); //restores lcd screen
}

/*WRITES THE system MENU ON THE SCREEN*/
void system_menu(short x, short y){
	DrawStr(x+13,y+3,"APD",A_XOR);
	DrawStr(x+13,y+13,"Key Speed",A_XOR);
	DrawStr(x+13,y+23,"Password",A_XOR);
	DrawStr(x+8,y+33,"Splash screen",A_XOR);
}

/*system WINDOW*/
void system_win(WINDOW *wind, char ispass[1], char password[9], char splashScreen[1]){
  short width=60;
	short height=30; 
	short x = (LCD_WIDTH/2) - (width/2);
	short y = (LCD_HEIGHT/2) - (height/2);
	drawbox(x,y+3,width,6,1,A_OR);
	system_menu(x,y);
	ST_refDsp (12);
	int menu_point=0;
	short y1=y+3;
	int key= ngetchx();
	while (key != KEY_ESC){
		if (key != (KEY_DOWN || KEY_UP || KEY_ESC || KEY_ENTER)){
	  ST_refDsp (12);
		menu_point=menu_point;
		key=key;
		}
		if (key==KEY_ENTER){
			if (menu_point==0){
				WinClr(wind);
				APD_win(wind);
				WinClr(wind);
				drawbox(x,y1,width,6,1,A_OR);
		  	system_menu(x,y);
			}
		  if (menu_point==1){
		  	WinClr(wind);
				key_win(wind);
				WinClr(wind);
				drawbox(x,y1,width,6,1,A_OR);
		  	system_menu(x,y);
		  }
		  if (menu_point==2){
		  	WinClr(wind);
				pass_win(wind,ispass,password);
				WinClr(wind);
				drawbox(x,y1,width,6,1,A_OR);
		  	system_menu(x,y);
		  }
		  if (menu_point==3){
		  	WinClr(wind);
				intro_win(wind,splashScreen);
				WinClr(wind);
				drawbox(x,y1,width,6,1,A_OR);
		  	system_menu(x,y);
		  }
		} 
		if(key == KEY_DOWN){ 
		  WinClr (wind);
		  if (menu_point!=3 ){
				y1=y1+10;
				drawbox(x,y1,width,6,1,A_OR);
		  	system_menu(x,y);
				menu_point=menu_point+1;
    	}else{
				y1=y+3;
				drawbox(x,y1,width,6,1,A_OR);
				system_menu(x,y);
				menu_point=0;
    	}
		}
		if(key == KEY_UP){ 
		  WinClr (wind);
		  if (menu_point !=0 ){
				y1=y1-10;
				drawbox(x,y1,width,6,1,A_OR);
				system_menu(x,y);
				menu_point=menu_point-1;
			}else{
				y1=y+33;
				drawbox(x,y1,width,6,1,A_OR);
		  	system_menu(x,y);
				menu_point=3;
    	}		
		}
	key=ngetchx();
	}
}

/*WRITES THE apd MENU ON THE SCREEN*/
void APD_menu(short x, short y){
	DrawStr(x+13,y+3,"DEFAULT",A_XOR);
	DrawStr(x+13,y+13,"CUSTOMIZE",A_XOR);
}

/*APD WINDOW*/
void APD_win(WINDOW *wind){
  short width=60;
	short height=15; 
	short x = (LCD_WIDTH/2) - (width/2);
	short y = (LCD_HEIGHT/2) - (height/2);
	drawbox(x,y+3,width,6,1,A_OR);
	APD_menu(x,y);
	ST_refDsp (12);
	int menu_point=0;
	short y1=y+3;
	int key= ngetchx();
	while (key != KEY_ESC){
		if (key != (KEY_DOWN || KEY_UP || KEY_ESC || KEY_ENTER)){
	  ST_refDsp (12);
		menu_point=menu_point;
		key=key;
		}
		if (key==KEY_ENTER){
			if (menu_point==0){
				APD_NORMAL();						
		  }
		  if (menu_point==1){
		  		WinClr(wind);
		  		APD_custom_win(wind);
		  		WinClr(wind);
		  		drawbox(x,y1,width,6,1,A_OR);
		  	  APD_menu(x,y);
		  }
		} 
		if(key == KEY_DOWN){ 
		  WinClr (wind);
		  if (menu_point!=1 ){
				y1=y1+10;
				drawbox(x,y1,width,6,1,A_OR);
		  	APD_menu(x,y);
				menu_point=menu_point+1;
    	}else{
				y1=y+3;
				drawbox(x,y1,width,6,1,A_OR);
				APD_menu(x,y);
				menu_point=0;
    	}
		}
		if(key == KEY_UP){ 
		  WinClr (wind);
		  if (menu_point !=0 ){
				y1=y1-10;
				drawbox(x,y1,width,6,1,A_OR);
				APD_menu(x,y);
				menu_point=menu_point-1;
			}else{
				y1=y+13;
				drawbox(x,y1,width,6,1,A_OR);
		  	APD_menu(x,y);
				menu_point=1;
    	}		
		}
	key=ngetchx();
	}
}
void APD_NORMAL(void){
	OSFreeTimer (APD_TIMER);
	OSRegisterTimer (APD_TIMER, 300*20);
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
    WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-55,(LCD_HEIGHT/2)-25, (LCD_WIDTH/2)+55, (LCD_HEIGHT/2)+5), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"Automatic Power Down");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, "AUTOMATIC POWER DOWN");
  WinStr (wind, "\n");
  WinStr (wind, "SET IN DEFAULT MODE");
  ngetchx();
  WinClose (wind);
  HeapFreePtr (wind);
}

/*Apd in seconds*/
void APD_SEGUNDOS(void){
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-65,(LCD_HEIGHT/2)-45, (LCD_WIDTH/2)+65, (LCD_HEIGHT/2)+20), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"Automatic Power Down");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, "\n*Type in the time then press ENTER");
  WinStr (wind, "\n*Time must be in Seconds");
  int t;
  char apdt[9];
  MoveTo((LCD_WIDTH/2)-5,(LCD_HEIGHT/2)+10);
	t = InputStr(apdt, 9);
  OSFreeTimer (APD_TIMER);
	OSRegisterTimer (APD_TIMER, t*20);
  WinClose (wind);
  HeapFreePtr (wind);
}

/*Apd in minutes*/
void APD_minutos(void){
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-65,(LCD_HEIGHT/2)-45, (LCD_WIDTH/2)+65, (LCD_HEIGHT/2)+20), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"Automatic Power Down");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, "\n*Type in the time then press ENTER");
  WinStr (wind, "\n*Time must be in Minutess");
  int t;
  char apdt[9];
  MoveTo((LCD_WIDTH/2)-5,(LCD_HEIGHT/2)+10);
	t = InputStr(apdt, 9);
  OSFreeTimer (APD_TIMER);
	OSRegisterTimer (APD_TIMER, t*1200);
  WinClose (wind);
  HeapFreePtr (wind);
}

/*WRITES THE apd customize MENU ON THE SCREEN*/
void APD_custom_menu(short x, short y){
	DrawStr(x+13,y+3,"SECONDS",A_XOR);
	DrawStr(x+13,y+13,"MINUTES",A_XOR);
}

/*customize apd window*/
void APD_custom_win(WINDOW *wind){
  short width=60;
	short height=15; 
	short x = (LCD_WIDTH/2) - (width/2);
	short y = (LCD_HEIGHT/2) - (height/2);
	drawbox(x,y+3,width,6,1,A_OR);
	APD_custom_menu(x,y);
	ST_refDsp (12);
	int menu_point=0;
	short y1=y+3;
	int key= ngetchx();
	while (key != KEY_ESC){
		if (key != (KEY_DOWN || KEY_UP || KEY_ESC || KEY_ENTER)){
	  ST_refDsp (12);
		menu_point=menu_point;
		key=key;
		}
		if (key==KEY_ENTER){
			if (menu_point==0){
				APD_SEGUNDOS();						
		  }
		  if (menu_point==1){
		  		APD_minutos();
		  }
		} 
		if(key == KEY_DOWN){ 
		  WinClr (wind);
		  if (menu_point!=1 ){
				y1=y1+10;
				drawbox(x,y1,width,6,1,A_OR);
		  	APD_custom_menu(x,y);
				menu_point=menu_point+1;
    	}else{
				y1=y+3;
				drawbox(x,y1,width,6,1,A_OR);
				APD_custom_menu(x,y);
				menu_point=0;
    	}
		}
		if(key == KEY_UP){ 
		  WinClr (wind);
		  if (menu_point !=0 ){
				y1=y1-10;
				drawbox(x,y1,width,6,1,A_OR);
				APD_custom_menu(x,y);
				menu_point=menu_point-1;
			}else{
				y1=y+13;
				drawbox(x,y1,width,6,1,A_OR);
		  	APD_custom_menu(x,y);
				menu_point=1;
    	}		
		}
	key=ngetchx();
	}
}

/*WRITES THE KEY SPEED MENU ON THE SCREEN*/
void key_menu(short x, short y){
	DrawStr(x+13,y+3,"DEFAULT",A_XOR);
	DrawStr(x+13,y+13,"FAST",A_XOR);
	DrawStr(x+13,y+23,"SLOW",A_XOR);
	DrawStr(x+10,y+33,"CUSTOMIZE",A_XOR);
}

/*KEY SPEED WINDOW*/
void key_win(WINDOW *wind){
  short width=60;
	short height=30; 
	short x = (LCD_WIDTH/2) - (width/2);
	short y = (LCD_HEIGHT/2) - (height/2);
	drawbox(x,y+3,width,6,1,A_OR);
	key_menu(x,y);
	ST_refDsp (12);
	int menu_point=0;
	short y1=y+3;
	int key= ngetchx();
	while (key != KEY_ESC){
		if (key != (KEY_DOWN || KEY_UP || KEY_ESC || KEY_ENTER)){
	  ST_refDsp (12);
		menu_point=menu_point;
		key=key;
		}
		if (key==KEY_ENTER){
			if (menu_point==0){
			  	keyRep_Normal();
			}
		  if (menu_point==1){
		  		keyRep_Fast();
		  }
		  if (menu_point==2){
			  	keyRep_slow();
			}
		  if (menu_point==3){
		  		KeyRep();
		  }
		} 
		if(key == KEY_DOWN){ 
		  WinClr (wind);
		  if (menu_point!=3 ){
				y1=y1+10;
				drawbox(x,y1,width,6,1,A_OR);
		  	key_menu(x,y);
				menu_point=menu_point+1;
    	}else{
				y1=y+3;
				drawbox(x,y1,width,6,1,A_OR);
				key_menu(x,y);
				menu_point=0;
    	}
		}
		if(key == KEY_UP){ 
		  WinClr (wind);
		  if (menu_point !=0 ){
				y1=y1-10;
				drawbox(x,y1,width,6,1,A_OR);
				key_menu(x,y);
				menu_point=menu_point-1;
			}else{
				y1=y+33;
				drawbox(x,y1,width,6,1,A_OR);
		  	key_menu(x,y);
				menu_point=3;
    	}		
		}
	key=ngetchx();
	}
}
/*key repetiton*/
void KeyRep(void){
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-65,(LCD_HEIGHT/2)-45, (LCD_WIDTH/2)+65, (LCD_HEIGHT/2)+20), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"Key speed");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  again:
  WinClr(wind);
  WinStr (wind, "Keyboard speed it's from 2 (fast) to 395 (slow)");
  WinStr (wind, "\nType in the Time (Default = 48) then press ENTER:");
  MoveTo((LCD_WIDTH/2)-5,(LCD_HEIGHT/2)+10);
	char buffer2[3];
	int c =InputStr(buffer2,3);
	if (c>395||c<2) goto again;
	OSInitBetweenKeyDelay (c);
	WinClose (wind);
  HeapFreePtr (wind);
	return;
	
}

void keyRep_Fast(void){
	OSInitBetweenKeyDelay (20);
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-65,(LCD_HEIGHT/2)-25, (LCD_WIDTH/2)+65, (LCD_HEIGHT/2)+5), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"KeyBoard speed");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, "The keyboard speed has been set in   fast mode");
  ngetchx();
  WinClose (wind);
  HeapFreePtr (wind);
}
void keyRep_slow(void){	
	OSInitBetweenKeyDelay (220);
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-65,(LCD_HEIGHT/2)-25, (LCD_WIDTH/2)+65, (LCD_HEIGHT/2)+5), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"KeyBoard speed");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, "The keyboard speed has been set in   slow mode");
  ngetchx();
  WinClose (wind);
  HeapFreePtr (wind);
}
void keyRep_Normal(void){
	OSInitBetweenKeyDelay (48);
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-65,(LCD_HEIGHT/2)-25, (LCD_WIDTH/2)+65, (LCD_HEIGHT/2)+5), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"KeyBoard speed");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, "The keyboard speed has been set in   default mode");
  ngetchx();
  WinClose (wind);
  HeapFreePtr (wind);
}

/*WRITES THE PASSWORD MENU ON THE SCREEN*/
void pass_menu(short x, short y){
	DrawStr(x+13,y+3,"SET PASS",A_XOR);
	DrawStr(x+13,y+13,"PASS OFF",A_XOR);
}

/*PASSWORD WINDOW*/
void pass_win(WINDOW *wind,char ispass[1], char password[9]){
  short width=60;
	short height=15; 
	short x = (LCD_WIDTH/2) - (width/2);
	short y = (LCD_HEIGHT/2) - (height/2);
	drawbox(x,y+3,width,6,1,A_OR);
	pass_menu(x,y);
	ST_refDsp (12);
	int menu_point=0;
	short y1=y+3;
	int key= ngetchx();
	while (key != KEY_ESC){
		if (key != (KEY_DOWN || KEY_UP || KEY_ESC || KEY_ENTER)){
	  ST_refDsp (12);
		menu_point=menu_point;
		key=key;
		}
		if (key==KEY_ENTER){
			if (menu_point==0){
				setPassword(password,ispass);
		  }
		  if (menu_point==1){
		  	ispass[0]='n';
		  	no_pass();	
		  }
		} 
		if(key == KEY_DOWN){ 
		  WinClr (wind);
		  if (menu_point!=1 ){
				y1=y1+10;
				drawbox(x,y1,width,6,1,A_OR);
		  	pass_menu(x,y);
				menu_point=menu_point+1;
			}else{
				y1=y+3;
				drawbox(x,y1,width,6,1,A_OR);
				pass_menu(x,y);
				menu_point=0;
			}
		}
		if(key == KEY_UP){ 
		  WinClr (wind);
		  if (menu_point !=0 ){
				y1=y1-10;
				drawbox(x,y1,width,6,1,A_OR);
				pass_menu(x,y);
				menu_point=menu_point-1;
    	}else{
				y1=y+13;
				drawbox(x,y1,width,6,1,A_OR);
		  	pass_menu(x,y);
				menu_point=1;
    	}		
		}
	key=ngetchx();
	}
}

/*no password window*/
void no_pass(void){
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-55,(LCD_HEIGHT/2)-25, (LCD_WIDTH/2)+55, (LCD_HEIGHT/2)+5), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"Automatic Power Down");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, "Password protection off");
  ngetchx();
  WinClose (wind);
  HeapFreePtr (wind);
}


/*WRITES THE intro MENU ON THE SCREEN*/
void intro_menu(short x, short y){
	DrawStr(x+13,y+3,"INTRO ON",A_XOR);
	DrawStr(x+13,y+13,"INTRO OFF",A_XOR);
}

/*INTRO WINDOW*/
void intro_win(WINDOW *wind,char splashScreen[1]){
  short width=60;
	short height=15; 
	short x = (LCD_WIDTH/2) - (width/2);
	short y = (LCD_HEIGHT/2) - (height/2);
	drawbox(x,y+3,width,6,1,A_OR);
	intro_menu(x,y);
	ST_refDsp (12);
	int menu_point=0;
	short y1=y+3;
	int key= ngetchx();
	while (key != KEY_ESC){
		if (key != (KEY_DOWN || KEY_UP || KEY_ESC || KEY_ENTER)){
	  ST_refDsp (12);
		menu_point=menu_point;
		key=key;
		}
		if (key==KEY_ENTER){
			if (menu_point==0){
				splashScreen[0]='s';
				yes_intro();
		  }
		  if (menu_point==1){
		  	splashScreen[0]='n';
		  	no_intro();
		  }
		} 
		if(key == KEY_DOWN){ 
		  WinClr (wind);
		  if (menu_point!=1 ){
				y1=y1+10;
				drawbox(x,y1,width,6,1,A_OR);
		  	intro_menu(x,y);
				menu_point=menu_point+1;
			}else{
				y1=y+3;
				drawbox(x,y1,width,6,1,A_OR);
				intro_menu(x,y);
				menu_point=0;
			}
		}
		if(key == KEY_UP){ 
		  WinClr (wind);
		  if (menu_point !=0 ){
				y1=y1-10;
				drawbox(x,y1,width,6,1,A_OR);
				intro_menu(x,y);
				menu_point=menu_point-1;
    	}else{
				y1=y+13;
				drawbox(x,y1,width,6,1,A_OR);
		  	intro_menu(x,y);
				menu_point=1;
    	}		
		}
	key=ngetchx();
	}
}
/*no intro window*/
void no_intro(void){
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-55,(LCD_HEIGHT/2)-25, (LCD_WIDTH/2)+55, (LCD_HEIGHT/2)+5), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"Automatic Power Down");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, "Splash Screen off");
  ngetchx();
  WinClose (wind);
  HeapFreePtr (wind);
}
/*yes intro window*/
void yes_intro(void){
	WINDOW *wind = HeapAllocPtr (sizeof (WINDOW));
  WinOpen (wind, MakeWinRect ((LCD_WIDTH/2)-55,(LCD_HEIGHT/2)-25, (LCD_WIDTH/2)+55, (LCD_HEIGHT/2)+5), WF_SAVE_SCR | WF_TTY | WF_ROUNDEDBORDER | WF_TITLE ,"Automatic Power Down");
  WinActivate (wind);
  WinFont (wind, F_4x6);
  WinStr (wind, "Splash Screen On");
  ngetchx();
  WinClose (wind);
  HeapFreePtr (wind);
}
// Custom String Input Function
int InputStr(char *buffer, unsigned short maxlen)
{
  SCR_STATE ss;
  short key;
  unsigned short i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_  ", buffer);
        // Note that two spaces are required only if the F_4x6 font is used
      key = ngetchx ();
      if (key >= '0' && key <= '9' && i < maxlen)
        buffer[i++] = key;
        else if (key == KEY_BACKSPACE && i)
        i--;
        buffer[i] = 0;
    } while (key != KEY_ENTER);
	int k=atol(buffer);
	return k;
}




